/**
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright (c) 2015 ForgeRock AS. All rights reserved.
 *
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the License). You may not use this file except in
 * compliance with the License.
 *
 * You can obtain a copy of the License at
 * http://forgerock.org/license/CDDLv1.0.html
 * See the License for the specific language governing
 * permission and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL
 * Header Notice in each file and include the License file
 * at http://forgerock.org/license/CDDLv1.0.html
 * If applicable, add the following below the CDDL Header,
 * with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 */

/*global define, $, _, Handlebars, form2js */

define("org/forgerock/openidm/ui/admin/settings/SettingsView", [
    "org/forgerock/openidm/ui/admin/util/AdminAbstractView",
    "org/forgerock/openidm/ui/admin/settings/AuthenticationView",
    "org/forgerock/openidm/ui/admin/settings/AuditView",
    "org/forgerock/openidm/ui/admin/settings/SelfServiceView",
    "org/forgerock/openidm/ui/admin/settings/EmailConfigView",
    "bootstrap-tabdrop"

], function(AdminAbstractView,
            AuthenticationView,
            AuditView,
            SelfServiceView,
            EmailConfigView,
            tabdrop) {

    var SettingsView = AdminAbstractView.extend({
        template: "templates/admin/settings/SettingsTemplate.html",
        events: {},
        render: function(args, callback) {
            this.parentRender(_.bind(function () {
                AuthenticationView.render();
                //AuditView.render();
                SelfServiceView.render();
                EmailConfigView.render();

                this.$el.find(".nav-tabs").tabdrop();
            }, this));
        }
    });

    return new SettingsView();
});