/*global require, define*/
define(function () {

    return function (server) {
        
        server.respondWith(
            "GET",   
            "/openidm/config/managed",
            [
                200, 
                {},
                "{\"objects\":[{\"name\":\"user\",\"onCreate\":{\"type\":\"text/javascript\",\"file\":\"ui/onCreate-user-set-default-fields.js\"},\"onDelete\":{\"type\":\"text/javascript\",\"file\":\"ui/onDelete-user-cleanup.js\"},\"properties\":[{\"name\":\"securityAnswer\",\"encryption\":{\"key\":\"openidm-sym-default\"},\"scope\":\"private\"},{\"name\":\"password\",\"encryption\":{\"key\":\"openidm-sym-default\"},\"scope\":\"private\"},{\"name\":\"effectiveRoles\",\"type\":\"virtual\",\"onRetrieve\":{\"type\":\"text/javascript\",\"file\":\"roles/effectiveRoles.js\",\"rolesPropName\":\"roles\"}},{\"name\":\"effectiveAssignments\",\"type\":\"virtual\",\"onRetrieve\":{\"type\":\"text/javascript\",\"file\":\"roles/effectiveAssignments.js\",\"effectiveRolesPropName\":\"effectiveRoles\"}}],\"schema\":{\"id\":\"http://jsonschema.net\",\"title\":\"User\",\"viewable\":true,\"$schema\":\"http://json-schema.org/draft-03/schema\",\"order\":[\"userName\",\"givenName\",\"sn\",\"mail\",\"accountStatus\",\"telephoneNumber\",\"postalAddress\",\"address2\",\"city\",\"postalCode\",\"country\",\"stateProvince\",\"roles\",\"manager\"],\"properties\":{\"mail\":{\"title\":\"Email Address\",\"viewable\":true,\"type\":\"string\",\"searchable\":true},\"sn\":{\"title\":\"Last Name\",\"viewable\":true,\"type\":\"string\",\"searchable\":true},\"address2\":{\"type\":\"string\",\"title\":\"Address 2\",\"viewable\":true},\"givenName\":{\"title\":\"First Name\",\"viewable\":true,\"type\":\"string\",\"searchable\":true},\"city\":{\"type\":\"string\",\"title\":\"City\",\"viewable\":true},\"country\":{\"type\":\"string\",\"title\":\"Country\",\"viewable\":true},\"postalCode\":{\"type\":\"string\",\"title\":\"Postal Code\",\"viewable\":true},\"accountStatus\":{\"title\":\"Status\",\"viewable\":true,\"type\":\"string\",\"searchable\":true},\"roles\":{\"description\":\"\",\"title\":\"Roles\",\"viewable\":true,\"type\":\"array\",\"items\":{\"type\":\"string\",\"resourceCollection\":{\"path\":\"managed/role\",\"query\":{\"queryFilter\":\"true\",\"fields\":[\"properties/name\"],\"sortKeys\":[\"properties/name\"]}}}},\"telephoneNumber\":{\"type\":\"string\",\"title\":\"Mobile Phone\",\"viewable\":true},\"stateProvince\":{\"type\":\"string\",\"title\":\"State/Province\",\"viewable\":true},\"postalAddress\":{\"type\":\"string\",\"title\":\"Address 1\",\"viewable\":true},\"userName\":{\"title\":\"Username\",\"viewable\":true,\"type\":\"string\",\"searchable\":true},\"manager\":{\"description\":\"\",\"title\":\"Manager\",\"viewable\":true,\"searchable\":false,\"resourceCollection\":{\"path\":\"managed/user\",\"label\":\"Reports\",\"query\":{\"queryFilter\":\"true\",\"fields\":[\"userName\",\"givenName\",\"sn\"],\"sortKeys\":[\"userName\"]}},\"type\":\"string\"}},\"type\":\"object\",\"required\":[\"userName\",\"givenName\",\"sn\",\"mail\"]}},{\"name\":\"role\",\"postCreate\":{\"type\":\"text/javascript\",\"file\":\"roles/update-users-of-role.js\"},\"postUpdate\":{\"type\":\"text/javascript\",\"file\":\"roles/update-users-of-role.js\"},\"postDelete\":{\"type\":\"text/javascript\",\"file\":\"roles/update-users-of-role.js\"},\"onDelete\":{\"type\":\"text/javascript\",\"file\":\"roles/onDelete-roles.js\"},\"schema\":{\"$schema\":\"http://forgerock.org/json-schema#\",\"type\":\"object\",\"title\":\"Role\",\"description\":\"\",\"properties\":{\"_id\":{\"description\":\"\",\"title\":\"Name\",\"viewable\":false,\"searchable\":false,\"type\":\"string\"},\"properties\":{\"description\":\"\",\"title\":\"Properties\",\"viewable\":true,\"searchable\":false,\"type\":\"object\",\"properties\":{\"name\":{\"description\":\"The role name, used for display purposes.\",\"title\":\"Name\",\"viewable\":true,\"searchable\":true,\"type\":\"string\"},\"description\":{\"description\":\"\",\"title\":\"Description\",\"viewable\":true,\"searchable\":true,\"type\":\"string\"}},\"required\":[\"name\",\"description\"],\"order\":[\"name\",\"description\"]},\"assignments\":{\"description\":\"\",\"title\":\"Assignments\",\"viewable\":true,\"searchable\":false,\"type\":\"string\"}},\"required\":[\"_id\",\"properties\"],\"order\":[\"_id\",\"properties\",\"assignments\"]}}],\"_id\":\"managed\"}"
            ]
        );
    
        server.respondWith(
            "POST",   
            "/openidm/managed/user?_action=create",
            [
                201, 
                {},
                "{\"mail\":\"newUser@newUserSite.com\",\"sn\":\"User\",\"address2\":\"\",\"givenName\":\"New\",\"city\":\"\",\"country\":\"\",\"postalCode\":\"\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"telephoneNumber\":\"\",\"stateProvince\":\"\",\"postalAddress\":\"\",\"userName\":\"newUser\",\"manager\":\"\",\"lastPasswordSet\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Thu Jun 04 2015 10:04:29 GMT-0700 (PDT)\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":{},\"_id\":\"9082c2fd-451a-40d3-b194-0fd2f1bc8b98\",\"_rev\":\"1\"}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/managed/user/9082c2fd-451a-40d3-b194-0fd2f1bc8b98",
            [
                200, 
                {},
                "{\"mail\":\"newUser@newUserSite.com\",\"sn\":\"User\",\"address2\":\"\",\"givenName\":\"New\",\"city\":\"\",\"country\":\"\",\"postalCode\":\"\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"telephoneNumber\":\"\",\"stateProvince\":\"\",\"postalAddress\":\"\",\"userName\":\"newUser\",\"manager\":\"\",\"lastPasswordSet\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Thu Jun 04 2015 10:04:29 GMT-0700 (PDT)\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":{},\"_id\":\"9082c2fd-451a-40d3-b194-0fd2f1bc8b98\",\"_rev\":\"1\"}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/managed/user?_queryFilter=manager eq \"managed/user/9082c2fd-451a-40d3-b194-0fd2f1bc8b98\"&_pageSize=100&_sortKeys=userName",
            [
                200, 
                {},
                "{\"result\":[],\"resultCount\":0,\"pagedResultsCookie\":null,\"remainingPagedResults\":0}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/endpoint/linkedView/managed/user/9082c2fd-451a-40d3-b194-0fd2f1bc8b98",
            [
                200, 
                {},
                "{\"mail\":\"newUser@newUserSite.com\",\"sn\":\"User\",\"address2\":\"\",\"givenName\":\"New\",\"city\":\"\",\"country\":\"\",\"postalCode\":\"\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"telephoneNumber\":\"\",\"stateProvince\":\"\",\"postalAddress\":\"\",\"userName\":\"newUser\",\"manager\":\"\",\"lastPasswordSet\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Thu Jun 04 2015 10:04:29 GMT-0700 (PDT)\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":{},\"_id\":\"9082c2fd-451a-40d3-b194-0fd2f1bc8b98\",\"_rev\":\"1\",\"linkedTo\":[{\"linkQualifier\":\"default\",\"content\":{\"uid\":\"newUser\",\"sn\":\"User\",\"cn\":\"New User\",\"ldapGroups\":[],\"telephoneNumber\":null,\"givenName\":\"New\",\"employeeType\":null,\"dn\":\"uid=newUser,ou=People,dc=example,dc=com\",\"description\":null,\"mail\":\"newUser@newUserSite.com\",\"_id\":\"uid=newUser,ou=People,dc=example,dc=com\"},\"mappings\":[{\"name\":\"systemLdapAccounts_managedUser\",\"type\":\"source\"},{\"name\":\"managedUser_systemLdapAccounts\",\"type\":\"target\"}],\"linkType\":\"systemLdapAccounts_managedUser\",\"resourceName\":\"system/ldap/account/uid=newUser,ou=People,dc=example,dc=com\"}]}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/endpoint/linkedView/managed/user/9082c2fd-451a-40d3-b194-0fd2f1bc8b98",
            [
                200, 
                {},
                "{\"mail\":\"newUser@newUserSite.com\",\"sn\":\"User\",\"address2\":\"\",\"givenName\":\"New\",\"city\":\"\",\"country\":\"\",\"postalCode\":\"\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"telephoneNumber\":\"\",\"stateProvince\":\"\",\"postalAddress\":\"\",\"userName\":\"newUser\",\"manager\":\"\",\"lastPasswordSet\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Thu Jun 04 2015 10:04:29 GMT-0700 (PDT)\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":{},\"_id\":\"9082c2fd-451a-40d3-b194-0fd2f1bc8b98\",\"_rev\":\"1\",\"linkedTo\":[{\"linkQualifier\":\"default\",\"content\":{\"uid\":\"newUser\",\"sn\":\"User\",\"cn\":\"New User\",\"ldapGroups\":[],\"telephoneNumber\":null,\"givenName\":\"New\",\"employeeType\":null,\"dn\":\"uid=newUser,ou=People,dc=example,dc=com\",\"description\":null,\"mail\":\"newUser@newUserSite.com\",\"_id\":\"uid=newUser,ou=People,dc=example,dc=com\"},\"mappings\":[{\"name\":\"systemLdapAccounts_managedUser\",\"type\":\"source\"},{\"name\":\"managedUser_systemLdapAccounts\",\"type\":\"target\"}],\"linkType\":\"systemLdapAccounts_managedUser\",\"resourceName\":\"system/ldap/account/uid=newUser,ou=People,dc=example,dc=com\"}]}"
            ]
        );
    
        server.respondWith(
            "POST",   
            "/openidm/system/ldap?_action=test",
            [
                200, 
                {},
                "{\"name\":\"ldap\",\"enabled\":true,\"config\":\"config/provisioner.openicf/ldap\",\"objectTypes\":[\"__ALL__\",\"group\",\"account\"],\"connectorRef\":{\"connectorName\":\"org.identityconnectors.ldap.LdapConnector\",\"bundleName\":\"org.forgerock.openicf.connectors.ldap-connector\",\"bundleVersion\":\"[1.4.0.0,2.0.0.0)\"},\"displayName\":\"LDAP Connector\",\"ok\":true}"
            ]
        );
    
        server.respondWith(
            "POST",   
            "/openidm/system/ldap?_action=test",
            [
                200, 
                {},
                "{\"name\":\"ldap\",\"enabled\":true,\"config\":\"config/provisioner.openicf/ldap\",\"objectTypes\":[\"__ALL__\",\"group\",\"account\"],\"connectorRef\":{\"connectorName\":\"org.identityconnectors.ldap.LdapConnector\",\"bundleName\":\"org.forgerock.openicf.connectors.ldap-connector\",\"bundleVersion\":\"[1.4.0.0,2.0.0.0)\"},\"displayName\":\"LDAP Connector\",\"ok\":true}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/config/provisioner.openicf/ldap",
            [
                200, 
                {},
                "{\"name\":\"ldap\",\"connectorRef\":{\"bundleName\":\"org.forgerock.openicf.connectors.ldap-connector\",\"bundleVersion\":\"[1.4.0.0,2.0.0.0)\",\"connectorName\":\"org.identityconnectors.ldap.LdapConnector\"},\"configurationProperties\":{\"host\":\"localhost\",\"port\":1389,\"ssl\":false,\"principal\":\"cn=Directory Manager\",\"credentials\":{\"$crypto\":{\"value\":{\"iv\":\"ehuNmlvvrRRRnjzZUfHMCg==\",\"data\":\"H6oF/RGmU+MdgxLDHOoE5Q==\",\"cipher\":\"AES/CBC/PKCS5Padding\",\"key\":\"openidm-sym-default\"},\"type\":\"x-simple-encryption\"}},\"baseContexts\":[\"dc=example,dc=com\"],\"baseContextsToSynchronize\":[\"dc=example,dc=com\"],\"accountSearchFilter\":null,\"accountSynchronizationFilter\":null,\"groupSearchFilter\":null,\"groupSynchronizationFilter\":null,\"passwordAttributeToSynchronize\":null,\"synchronizePasswords\":false,\"removeLogEntryObjectClassFromFilter\":true,\"modifiersNamesToFilterOut\":[],\"passwordDecryptionKey\":null,\"changeLogBlockSize\":100,\"attributesToSynchronize\":[],\"changeNumberAttribute\":\"changeNumber\",\"passwordDecryptionInitializationVector\":null,\"filterWithOrInsteadOfAnd\":false,\"objectClassesToSynchronize\":[\"inetOrgPerson\"],\"vlvSortAttribute\":\"uid\",\"passwordAttribute\":\"userPassword\",\"useBlocks\":false,\"maintainPosixGroupMembership\":false,\"failover\":[],\"readSchema\":true,\"accountObjectClasses\":[\"top\",\"person\",\"organizationalPerson\",\"inetOrgPerson\"],\"accountUserNameAttributes\":[\"uid\"],\"groupMemberAttribute\":\"uniqueMember\",\"passwordHashAlgorithm\":null,\"usePagedResultControl\":true,\"blockSize\":100,\"uidAttribute\":\"dn\",\"maintainLdapGroupMembership\":false,\"respectResourcePasswordPolicyChangeAfterReset\":false},\"resultsHandlerConfig\":{\"enableNormalizingResultsHandler\":true,\"enableFilteredResultsHandler\":false,\"enableCaseInsensitiveFilter\":false,\"enableAttributesToGetSearchResultsHandler\":true},\"poolConfigOption\":{\"maxObjects\":10,\"maxIdle\":10,\"maxWait\":150000,\"minEvictableIdleTimeMillis\":120000,\"minIdle\":1},\"operationTimeout\":{\"CREATE\":-1,\"VALIDATE\":-1,\"TEST\":-1,\"SCRIPT_ON_CONNECTOR\":-1,\"SCHEMA\":-1,\"DELETE\":-1,\"UPDATE\":-1,\"SYNC\":-1,\"AUTHENTICATE\":-1,\"GET\":-1,\"SCRIPT_ON_RESOURCE\":-1,\"SEARCH\":-1},\"syncFailureHandler\":{\"maxRetries\":5,\"postRetryAction\":\"logged-ignore\"},\"objectTypes\":{\"account\":{\"$schema\":\"http://json-schema.org/draft-03/schema\",\"id\":\"__ACCOUNT__\",\"type\":\"object\",\"nativeType\":\"__ACCOUNT__\",\"properties\":{\"cn\":{\"type\":\"string\",\"nativeName\":\"cn\",\"nativeType\":\"string\"},\"employeeType\":{\"type\":\"string\",\"nativeName\":\"employeeType\",\"nativeType\":\"string\"},\"description\":{\"type\":\"string\",\"nativeName\":\"description\",\"nativeType\":\"string\"},\"givenName\":{\"type\":\"string\",\"nativeName\":\"givenName\",\"nativeType\":\"string\"},\"mail\":{\"type\":\"string\",\"nativeName\":\"mail\",\"nativeType\":\"string\"},\"telephoneNumber\":{\"type\":\"string\",\"nativeName\":\"telephoneNumber\",\"nativeType\":\"string\"},\"sn\":{\"type\":\"string\",\"nativeName\":\"sn\",\"nativeType\":\"string\"},\"uid\":{\"type\":\"string\",\"nativeName\":\"uid\",\"nativeType\":\"string\"},\"dn\":{\"type\":\"string\",\"nativeName\":\"__NAME__\",\"nativeType\":\"string\",\"required\":true},\"userPassword\":{\"type\":\"string\",\"nativeName\":\"userPassword\",\"nativeType\":\"string\",\"flags\":[\"NOT_READABLE\",\"NOT_RETURNED_BY_DEFAULT\"]},\"ldapGroups\":{\"type\":\"array\",\"items\":{\"type\":\"string\",\"nativeType\":\"string\"},\"nativeName\":\"ldapGroups\",\"nativeType\":\"string\"}}},\"group\":{\"$schema\":\"http://json-schema.org/draft-03/schema\",\"id\":\"__GROUP__\",\"type\":\"object\",\"nativeType\":\"__GROUP__\",\"properties\":{\"seeAlso\":{\"type\":\"array\",\"items\":{\"type\":\"string\",\"nativeType\":\"string\"},\"nativeName\":\"seeAlso\",\"nativeType\":\"string\"},\"description\":{\"type\":\"array\",\"items\":{\"type\":\"string\",\"nativeType\":\"string\"},\"nativeName\":\"description\",\"nativeType\":\"string\"},\"uniqueMember\":{\"type\":\"array\",\"items\":{\"type\":\"string\",\"nativeType\":\"string\"},\"nativeName\":\"uniqueMember\",\"nativeType\":\"string\"},\"dn\":{\"type\":\"string\",\"required\":true,\"nativeName\":\"__NAME__\",\"nativeType\":\"string\"},\"o\":{\"type\":\"array\",\"items\":{\"type\":\"string\",\"nativeType\":\"string\"},\"nativeName\":\"o\",\"nativeType\":\"string\"},\"ou\":{\"type\":\"array\",\"items\":{\"type\":\"string\",\"nativeType\":\"string\"},\"nativeName\":\"ou\",\"nativeType\":\"string\"},\"businessCategory\":{\"type\":\"array\",\"items\":{\"type\":\"string\",\"nativeType\":\"string\"},\"nativeName\":\"businessCategory\",\"nativeType\":\"string\"},\"owner\":{\"type\":\"array\",\"items\":{\"type\":\"string\",\"nativeType\":\"string\"},\"nativeName\":\"owner\",\"nativeType\":\"string\"},\"cn\":{\"type\":\"array\",\"items\":{\"type\":\"string\",\"nativeType\":\"string\"},\"required\":true,\"nativeName\":\"cn\",\"nativeType\":\"string\"}}}},\"operationOptions\":{\"DELETE\":{\"denied\":false,\"onDeny\":\"DO_NOTHING\"},\"UPDATE\":{\"denied\":false,\"onDeny\":\"DO_NOTHING\"},\"CREATE\":{\"denied\":false,\"onDeny\":\"DO_NOTHING\"}},\"_id\":\"provisioner.openicf/ldap\"}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/managed/user?_queryId=query-all-ids",
            [
                200, 
                {},
                "{\"result\":[{\"_id\":\"e5b6a78c-704e-4766-85c3-66ac06826228\",\"_rev\":\"1\"},{\"_id\":\"2d989ac8-c827-4dc3-b4cb-5ccf4ddabea6\",\"_rev\":\"1\"},{\"_id\":\"5e3e8d9f-95ce-42ae-b34f-e21e35087598\",\"_rev\":\"5\"},{\"_id\":\"601fc78d-ec21-4b87-a251-2d71eb4d9c18\",\"_rev\":\"1\"},{\"_id\":\"071bc8b0-7b69-4538-bfdc-44ff3eae664b\",\"_rev\":\"1\"},{\"_id\":\"772262d8-d9da-4094-bfbd-2716cd56d4b8\",\"_rev\":\"1\"},{\"_id\":\"87f4709b-c9a5-4717-a348-61d6bf2dc8be\",\"_rev\":\"1\"},{\"_id\":\"3039a9ce-efce-4727-ae04-8075b1083f38\",\"_rev\":\"1\"},{\"_id\":\"800d3398-6515-4e31-9d38-d62420ea4dd7\",\"_rev\":\"1\"},{\"_id\":\"e2f81f50-312f-4d21-85ca-c6013c813d14\",\"_rev\":\"1\"},{\"_id\":\"ac7ba936-5f1e-49f2-91c9-6d5c2f3ece6c\",\"_rev\":\"1\"},{\"_id\":\"268cc781-a725-4903-8063-f43c306e5d4e\",\"_rev\":\"1\"},{\"_id\":\"c7735786-50e7-4125-9fa1-03361d1ab82b\",\"_rev\":\"1\"},{\"_id\":\"d7a42435-d3ba-47b4-8f9b-1b5ed585c42c\",\"_rev\":\"1\"},{\"_id\":\"d9944fc1-c0bb-4fa7-acd8-bae66668746b\",\"_rev\":\"1\"},{\"_id\":\"ee7f510e-0456-4c6b-b0c2-72125432964b\",\"_rev\":\"1\"},{\"_id\":\"841bb59b-d753-4af8-ba67-9e70b87067a0\",\"_rev\":\"1\"},{\"_id\":\"172f47fb-7dae-4caa-90ce-7e15bc5f5614\",\"_rev\":\"1\"},{\"_id\":\"d8e92028-8abb-40ae-b760-607fcaa026f2\",\"_rev\":\"1\"},{\"_id\":\"c8ec8921-363e-4b4c-bf18-cd9035989c85\",\"_rev\":\"1\"},{\"_id\":\"dc2e09c9-910d-45d5-b55b-8ebb8f631495\",\"_rev\":\"1\"},{\"_id\":\"85f0a540-0deb-4225-ad5a-a14375487dd4\",\"_rev\":\"1\"},{\"_id\":\"d7313737-3173-452f-b064-8123a4b7ec04\",\"_rev\":\"1\"},{\"_id\":\"9082c2fd-451a-40d3-b194-0fd2f1bc8b98\",\"_rev\":\"2\"}],\"resultCount\":24,\"pagedResultsCookie\":null,\"remainingPagedResults\":-1}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/admin/templates/admin/resource/ListResourceViewTemplate.html",
            [
                200, 
                {},
                "<div id=\"{{grid_id}}_container\" class=\"container\">\n    {{#if validObject}}\n        <div class=\"page-header\">\n            <h1>{{pageTitle}} {{t \"common.form.list\"}}</h1>\n        </div>\n\n        <div class=\"btn-toolbar\" role=\"toolbar\" aria-label=\"toolbar\">\n            <div class=\"btn-group\" role=\"group\" aria-label=\"add resource\">\n                <a href=\"{{addLinkHref}}\" title=\"{{t \"templates.admin.ResourceEdit.new\"}} {{pageTitle}}\"><button class=\"btn btn-primary\" type=\"button\"><span class=\"fa fa-plus\"></span> {{t \"templates.admin.ResourceEdit.new\"}} {{pageTitle}}</button></a>\n            </div>\n            {{#if hasData}}\n                <div class=\"btn-group pull-right\" role=\"group\" aria-label=\"delete selected\">\n                    <button type=\"button\"  class=\"btn btn-default\"  id=\"deleteSelected\" disabled><span class=\"fa fa-trash\"></span>{{t 'common.form.deleteSelected'}}</button>\n                </div>\n                <div class=\"btn-group pull-right\" role=\"group\" aria-label=\"clear filters\">\n                    <button type=\"button\"  class=\"btn btn-default\"  id=\"clearFiltersBtn\"><span class=\"fa fa-times\"></span>{{t 'common.form.clearFilters'}}</button>\n                </div>\n                <div class=\"btn-group pull-right\" role=\"group\" aria-label=\"reload grid\">\n                   <a href=\"#\"><button type=\"button\"  class=\"btn btn-default\"  id=\"reloadGridBtn\"><span class=\"fa fa-refresh\"></span>{{t 'common.form.reloadGrid'}}</button></a>\n                </div>\n            {{/if}}\n        </div>\n    {{else}}\n        <div class=\"page-header\">\n            <h1>{{t \"templates.admin.ResourceList.invalidObject\"}}</h1>\n        </div>\n    {{/if}}\n\n    <div class=\"resourcesContainer panel panel-default\">\n        <table id=\"{{grid_id}}\">\n            <tr><td class=\"noData\">{{t \"templates.admin.ResourceList.noData\"}}</td></tr>\n        </table>\n        <div id=\"{{grid_id}}_pager\"></div>\n    </div>\n</div>"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/managed/user?_queryFilter=/_id sw \"\"&_pageSize=10&_sortKeys=userName&_pagedResultsOffset=0",
            [
                200, 
                {},
                "{\"result\":[{\"_id\":\"85f0a540-0deb-4225-ad5a-a14375487dd4\",\"_rev\":\"1\",\"userName\":\"hradmin\",\"displayName\":\"HR Admin\",\"description\":\"This is the description for HR Admin\",\"givenName\":\"HR\",\"mail\":\"hradmin@maildomain.net\",\"telephoneNumber\":\"+1 685 622 6202\",\"sn\":\"Admin\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:12 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"9082c2fd-451a-40d3-b194-0fd2f1bc8b98\",\"_rev\":\"2\",\"userName\":\"newUser\",\"mail\":\"newUser@newUserSite.com\",\"sn\":\"User\",\"address2\":\"\",\"givenName\":\"New\",\"city\":\"\",\"country\":\"\",\"postalCode\":\"\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"telephoneNumber\":\"\",\"stateProvince\":\"\",\"postalAddress\":\"\",\"manager\":\"managed/user/85f0a540-0deb-4225-ad5a-a14375487dd4\",\"lastPasswordSet\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Thu Jun 04 2015 10:04:29 GMT-0700 (PDT)\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"dc2e09c9-910d-45d5-b55b-8ebb8f631495\",\"_rev\":\"1\",\"userName\":\"superadmin\",\"displayName\":\"Super Admin\",\"description\":\"This is the description for Super Admin\",\"givenName\":\"Super\",\"mail\":\"superadmin@maildomain.net\",\"telephoneNumber\":\"+1 685 622 6202\",\"sn\":\"Admin\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:12 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"d7313737-3173-452f-b064-8123a4b7ec04\",\"_rev\":\"1\",\"userName\":\"systemadmin\",\"displayName\":\"System\",\"description\":\"This is the description for System Admin.\",\"givenName\":\"System\",\"mail\":\"systemadmin@maildomain.net\",\"telephoneNumber\":\"+1 154 428 0080\",\"sn\":\"Admin\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:12 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"5e3e8d9f-95ce-42ae-b34f-e21e35087598\",\"_rev\":\"5\",\"userName\":\"user.0\",\"displayName\":\"Aaccf Amar\",\"description\":\"This is the description for Aaccf Amar.\",\"givenName\":\"Aaccf\",\"mail\":\"user.0@maildomain.net\",\"telephoneNumber\":\"+1 685 622 6202\",\"sn\":\"Amar\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:10 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"3039a9ce-efce-4727-ae04-8075b1083f38\",\"_rev\":\"1\",\"userName\":\"user.1\",\"displayName\":\"Aaren Atp\",\"description\":\"This is the description for Aaren Atp.\",\"givenName\":\"Aaren\",\"mail\":\"user.1@maildomain.net\",\"telephoneNumber\":\"+1 390 103 6917\",\"sn\":\"Atp\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:10 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"d9944fc1-c0bb-4fa7-acd8-bae66668746b\",\"_rev\":\"1\",\"userName\":\"user.10\",\"displayName\":\"Abbey Abbie\",\"description\":\"This is the description for Abbey Abbie.\",\"givenName\":\"Abbey\",\"mail\":\"user.10@maildomain.net\",\"telephoneNumber\":\"+1 883 194 7070\",\"sn\":\"Abbie\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:12 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"d7a42435-d3ba-47b4-8f9b-1b5ed585c42c\",\"_rev\":\"1\",\"userName\":\"user.11\",\"displayName\":\"Abbi Abbott\",\"description\":\"This is the description for Abbi Abbott.\",\"givenName\":\"Abbi\",\"mail\":\"user.11@maildomain.net\",\"telephoneNumber\":\"+1 591 537 3301\",\"sn\":\"Abbott\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:11 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"ac7ba936-5f1e-49f2-91c9-6d5c2f3ece6c\",\"_rev\":\"1\",\"userName\":\"user.12\",\"displayName\":\"Abbie Abdalla\",\"description\":\"This is the description for Abbie Abdalla.\",\"givenName\":\"Abbie\",\"mail\":\"user.12@maildomain.net\",\"telephoneNumber\":\"+1 062 873 3050\",\"sn\":\"Abdalla\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:10 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"c7735786-50e7-4125-9fa1-03361d1ab82b\",\"_rev\":\"1\",\"userName\":\"user.13\",\"displayName\":\"Abby Abdo\",\"description\":\"This is the description for Abby Abdo.\",\"givenName\":\"Abby\",\"mail\":\"user.13@maildomain.net\",\"telephoneNumber\":\"+1 049 261 0167\",\"sn\":\"Abdo\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:11 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null}],\"resultCount\":10,\"pagedResultsCookie\":\"10\",\"remainingPagedResults\":-1}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/managed/user/85f0a540-0deb-4225-ad5a-a14375487dd4",
            [
                200, 
                {},
                "{\"displayName\":\"HR Admin\",\"description\":\"This is the description for HR Admin\",\"givenName\":\"HR\",\"mail\":\"hradmin@maildomain.net\",\"telephoneNumber\":\"+1 685 622 6202\",\"sn\":\"Admin\",\"userName\":\"hradmin\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:12 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":{},\"_id\":\"85f0a540-0deb-4225-ad5a-a14375487dd4\",\"_rev\":\"1\"}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/managed/user?_queryFilter=manager eq \"managed/user/9082c2fd-451a-40d3-b194-0fd2f1bc8b98\"&_pageSize=100&_sortKeys=userName",
            [
                200, 
                {},
                "{\"result\":[],\"resultCount\":0,\"pagedResultsCookie\":null,\"remainingPagedResults\":0}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/endpoint/linkedView/managed/user/9082c2fd-451a-40d3-b194-0fd2f1bc8b98",
            [
                200, 
                {},
                "{\"mail\":\"newUser@newUserSite.com\",\"sn\":\"User\",\"address2\":\"\",\"givenName\":\"New\",\"city\":\"\",\"country\":\"\",\"postalCode\":\"\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"telephoneNumber\":\"\",\"stateProvince\":\"\",\"postalAddress\":\"\",\"userName\":\"newUser\",\"manager\":\"managed/user/85f0a540-0deb-4225-ad5a-a14375487dd4\",\"lastPasswordSet\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Thu Jun 04 2015 10:04:29 GMT-0700 (PDT)\",\"effectiveRoles\":[\"openidm-authorized\"],\"_id\":\"9082c2fd-451a-40d3-b194-0fd2f1bc8b98\",\"_rev\":\"2\",\"effectiveAssignments\":{},\"linkedTo\":[{\"linkQualifier\":\"default\",\"content\":{\"uid\":\"newUser\",\"sn\":\"User\",\"cn\":\"New User\",\"ldapGroups\":[],\"telephoneNumber\":null,\"givenName\":\"New\",\"employeeType\":null,\"dn\":\"uid=newUser,ou=People,dc=example,dc=com\",\"description\":null,\"mail\":\"newUser@newUserSite.com\",\"_id\":\"uid=newUser,ou=People,dc=example,dc=com\"},\"mappings\":[{\"name\":\"systemLdapAccounts_managedUser\",\"type\":\"source\"},{\"name\":\"managedUser_systemLdapAccounts\",\"type\":\"target\"}],\"linkType\":\"systemLdapAccounts_managedUser\",\"resourceName\":\"system/ldap/account/uid=newUser,ou=People,dc=example,dc=com\"}]}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/managed/user?_sortKeys=userName&_pageSize=10&_queryFilter=userName sw \"\" or (givenName sw \"\" or (sn sw \"\"))",
            [
                200, 
                {},
                "{\"result\":[{\"givenName\":\"HR\",\"sn\":\"Admin\",\"userName\":\"hradmin\",\"displayName\":\"HR Admin\",\"description\":\"This is the description for HR Admin\",\"mail\":\"hradmin@maildomain.net\",\"telephoneNumber\":\"+1 685 622 6202\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:12 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null,\"_id\":\"85f0a540-0deb-4225-ad5a-a14375487dd4\",\"_rev\":\"1\"},{\"sn\":\"User\",\"givenName\":\"New\",\"userName\":\"newUser\",\"mail\":\"newUser@newUserSite.com\",\"address2\":\"\",\"city\":\"\",\"country\":\"\",\"postalCode\":\"\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"telephoneNumber\":\"\",\"stateProvince\":\"\",\"postalAddress\":\"\",\"manager\":\"managed/user/85f0a540-0deb-4225-ad5a-a14375487dd4\",\"lastPasswordSet\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Thu Jun 04 2015 10:04:29 GMT-0700 (PDT)\",\"effectiveRoles\":[\"openidm-authorized\"],\"_id\":\"9082c2fd-451a-40d3-b194-0fd2f1bc8b98\",\"_rev\":\"2\",\"effectiveAssignments\":null},{\"givenName\":\"Super\",\"sn\":\"Admin\",\"userName\":\"superadmin\",\"displayName\":\"Super Admin\",\"description\":\"This is the description for Super Admin\",\"mail\":\"superadmin@maildomain.net\",\"telephoneNumber\":\"+1 685 622 6202\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:12 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null,\"_id\":\"dc2e09c9-910d-45d5-b55b-8ebb8f631495\",\"_rev\":\"1\"},{\"givenName\":\"System\",\"sn\":\"Admin\",\"userName\":\"systemadmin\",\"displayName\":\"System\",\"description\":\"This is the description for System Admin.\",\"mail\":\"systemadmin@maildomain.net\",\"telephoneNumber\":\"+1 154 428 0080\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:12 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null,\"_id\":\"d7313737-3173-452f-b064-8123a4b7ec04\",\"_rev\":\"1\"},{\"givenName\":\"Aaccf\",\"sn\":\"Amar\",\"userName\":\"user.0\",\"displayName\":\"Aaccf Amar\",\"description\":\"This is the description for Aaccf Amar.\",\"mail\":\"user.0@maildomain.net\",\"telephoneNumber\":\"+1 685 622 6202\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:10 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"_id\":\"5e3e8d9f-95ce-42ae-b34f-e21e35087598\",\"_rev\":\"5\",\"effectiveAssignments\":null},{\"givenName\":\"Aaren\",\"sn\":\"Atp\",\"userName\":\"user.1\",\"displayName\":\"Aaren Atp\",\"description\":\"This is the description for Aaren Atp.\",\"mail\":\"user.1@maildomain.net\",\"telephoneNumber\":\"+1 390 103 6917\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:10 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null,\"_id\":\"3039a9ce-efce-4727-ae04-8075b1083f38\",\"_rev\":\"1\"},{\"givenName\":\"Abbey\",\"sn\":\"Abbie\",\"userName\":\"user.10\",\"displayName\":\"Abbey Abbie\",\"description\":\"This is the description for Abbey Abbie.\",\"mail\":\"user.10@maildomain.net\",\"telephoneNumber\":\"+1 883 194 7070\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:12 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null,\"_id\":\"d9944fc1-c0bb-4fa7-acd8-bae66668746b\",\"_rev\":\"1\"},{\"givenName\":\"Abbi\",\"sn\":\"Abbott\",\"userName\":\"user.11\",\"displayName\":\"Abbi Abbott\",\"description\":\"This is the description for Abbi Abbott.\",\"mail\":\"user.11@maildomain.net\",\"telephoneNumber\":\"+1 591 537 3301\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:11 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null,\"_id\":\"d7a42435-d3ba-47b4-8f9b-1b5ed585c42c\",\"_rev\":\"1\"},{\"givenName\":\"Abbie\",\"sn\":\"Abdalla\",\"userName\":\"user.12\",\"displayName\":\"Abbie Abdalla\",\"description\":\"This is the description for Abbie Abdalla.\",\"mail\":\"user.12@maildomain.net\",\"telephoneNumber\":\"+1 062 873 3050\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:10 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null,\"_id\":\"ac7ba936-5f1e-49f2-91c9-6d5c2f3ece6c\",\"_rev\":\"1\"},{\"givenName\":\"Abby\",\"sn\":\"Abdo\",\"userName\":\"user.13\",\"displayName\":\"Abby Abdo\",\"description\":\"This is the description for Abby Abdo.\",\"mail\":\"user.13@maildomain.net\",\"telephoneNumber\":\"+1 049 261 0167\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:11 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null,\"_id\":\"c7735786-50e7-4125-9fa1-03361d1ab82b\",\"_rev\":\"1\"}],\"resultCount\":10,\"pagedResultsCookie\":\"10\",\"remainingPagedResults\":-1}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/managed/role?_sortKeys=properties/name&_pageSize=10&_queryFilter=properties/name sw \"\"",
            [
                200, 
                {},
                "{\"result\":[{\"properties\":{\"name\":\"newRole\",\"description\":\"newRole description\"},\"_id\":\"593bee03-1f4a-49ff-a8fd-8002f8114155\",\"_rev\":\"21\",\"assignments\":{\"yo\":{\"attributes\":[{\"name\":\"yo\",\"value\":\"yo\",\"assignmentOperation\":\"mergeWithTarget\",\"unassignmentOperation\":\"removeFromTarget\"}]}}}],\"resultCount\":1,\"pagedResultsCookie\":null,\"remainingPagedResults\":0}"
            ]
        );
    
        server.respondWith(
            "POST",   
            "/openidm/system/ldap?_action=test",
            [
                200, 
                {},
                "{\"name\":\"ldap\",\"enabled\":true,\"config\":\"config/provisioner.openicf/ldap\",\"objectTypes\":[\"__ALL__\",\"group\",\"account\"],\"connectorRef\":{\"connectorName\":\"org.identityconnectors.ldap.LdapConnector\",\"bundleName\":\"org.forgerock.openicf.connectors.ldap-connector\",\"bundleVersion\":\"[1.4.0.0,2.0.0.0)\"},\"displayName\":\"LDAP Connector\",\"ok\":true}"
            ]
        );
    
        server.respondWith(
            "PATCH",   
            "/openidm/managed/user/9082c2fd-451a-40d3-b194-0fd2f1bc8b98",
            [
                200, 
                {},
                "{\"mail\":\"newUser@newUserSite.com\",\"sn\":\"User\",\"address2\":\"\",\"givenName\":\"New\",\"city\":\"\",\"country\":\"\",\"postalCode\":\"\",\"accountStatus\":\"active\",\"telephoneNumber\":\"\",\"stateProvince\":\"\",\"postalAddress\":\"\",\"userName\":\"newUser\",\"manager\":\"managed/user/85f0a540-0deb-4225-ad5a-a14375487dd4\",\"lastPasswordSet\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Thu Jun 04 2015 10:04:29 GMT-0700 (PDT)\",\"effectiveRoles\":[\"openidm-authorized\",\"managed/role/593bee03-1f4a-49ff-a8fd-8002f8114155\"],\"_id\":\"9082c2fd-451a-40d3-b194-0fd2f1bc8b98\",\"_rev\":\"3\",\"effectiveAssignments\":{\"yo\":{\"attributes\":[{\"name\":\"yo\",\"value\":\"yo\",\"assignmentOperation\":\"mergeWithTarget\",\"unassignmentOperation\":\"removeFromTarget\",\"assignedThrough\":\"managed/role/593bee03-1f4a-49ff-a8fd-8002f8114155\"}]}},\"roles\":[\"openidm-authorized\",\"managed/role/593bee03-1f4a-49ff-a8fd-8002f8114155\"]}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/managed/user?_queryId=query-all-ids",
            [
                200, 
                {},
                "{\"result\":[{\"_id\":\"e5b6a78c-704e-4766-85c3-66ac06826228\",\"_rev\":\"1\"},{\"_id\":\"2d989ac8-c827-4dc3-b4cb-5ccf4ddabea6\",\"_rev\":\"1\"},{\"_id\":\"5e3e8d9f-95ce-42ae-b34f-e21e35087598\",\"_rev\":\"5\"},{\"_id\":\"601fc78d-ec21-4b87-a251-2d71eb4d9c18\",\"_rev\":\"1\"},{\"_id\":\"071bc8b0-7b69-4538-bfdc-44ff3eae664b\",\"_rev\":\"1\"},{\"_id\":\"772262d8-d9da-4094-bfbd-2716cd56d4b8\",\"_rev\":\"1\"},{\"_id\":\"87f4709b-c9a5-4717-a348-61d6bf2dc8be\",\"_rev\":\"1\"},{\"_id\":\"3039a9ce-efce-4727-ae04-8075b1083f38\",\"_rev\":\"1\"},{\"_id\":\"800d3398-6515-4e31-9d38-d62420ea4dd7\",\"_rev\":\"1\"},{\"_id\":\"e2f81f50-312f-4d21-85ca-c6013c813d14\",\"_rev\":\"1\"},{\"_id\":\"ac7ba936-5f1e-49f2-91c9-6d5c2f3ece6c\",\"_rev\":\"1\"},{\"_id\":\"268cc781-a725-4903-8063-f43c306e5d4e\",\"_rev\":\"1\"},{\"_id\":\"c7735786-50e7-4125-9fa1-03361d1ab82b\",\"_rev\":\"1\"},{\"_id\":\"d7a42435-d3ba-47b4-8f9b-1b5ed585c42c\",\"_rev\":\"1\"},{\"_id\":\"d9944fc1-c0bb-4fa7-acd8-bae66668746b\",\"_rev\":\"1\"},{\"_id\":\"ee7f510e-0456-4c6b-b0c2-72125432964b\",\"_rev\":\"1\"},{\"_id\":\"841bb59b-d753-4af8-ba67-9e70b87067a0\",\"_rev\":\"1\"},{\"_id\":\"172f47fb-7dae-4caa-90ce-7e15bc5f5614\",\"_rev\":\"1\"},{\"_id\":\"d8e92028-8abb-40ae-b760-607fcaa026f2\",\"_rev\":\"1\"},{\"_id\":\"c8ec8921-363e-4b4c-bf18-cd9035989c85\",\"_rev\":\"1\"},{\"_id\":\"dc2e09c9-910d-45d5-b55b-8ebb8f631495\",\"_rev\":\"1\"},{\"_id\":\"85f0a540-0deb-4225-ad5a-a14375487dd4\",\"_rev\":\"1\"},{\"_id\":\"d7313737-3173-452f-b064-8123a4b7ec04\",\"_rev\":\"1\"},{\"_id\":\"9082c2fd-451a-40d3-b194-0fd2f1bc8b98\",\"_rev\":\"3\"}],\"resultCount\":24,\"pagedResultsCookie\":null,\"remainingPagedResults\":-1}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/managed/user?_queryFilter=/_id+sw+\"\"&_pageSize=10&_sortKeys=userName&_pagedResultsOffset=0",
            [
                200, 
                {},
                "{\"result\":[{\"_id\":\"85f0a540-0deb-4225-ad5a-a14375487dd4\",\"_rev\":\"1\",\"userName\":\"hradmin\",\"displayName\":\"HR Admin\",\"description\":\"This is the description for HR Admin\",\"givenName\":\"HR\",\"mail\":\"hradmin@maildomain.net\",\"telephoneNumber\":\"+1 685 622 6202\",\"sn\":\"Admin\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:12 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"9082c2fd-451a-40d3-b194-0fd2f1bc8b98\",\"_rev\":\"3\",\"userName\":\"newUser\",\"mail\":\"newUser@newUserSite.com\",\"sn\":\"User\",\"address2\":\"\",\"givenName\":\"New\",\"city\":\"\",\"country\":\"\",\"postalCode\":\"\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\",\"managed/role/593bee03-1f4a-49ff-a8fd-8002f8114155\"],\"telephoneNumber\":\"\",\"stateProvince\":\"\",\"postalAddress\":\"\",\"manager\":\"managed/user/85f0a540-0deb-4225-ad5a-a14375487dd4\",\"lastPasswordSet\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Thu Jun 04 2015 10:04:29 GMT-0700 (PDT)\",\"effectiveRoles\":[\"openidm-authorized\",\"managed/role/593bee03-1f4a-49ff-a8fd-8002f8114155\"],\"effectiveAssignments\":{\"yo\":{\"attributes\":[{\"name\":\"yo\",\"value\":\"yo\",\"assignmentOperation\":\"mergeWithTarget\",\"unassignmentOperation\":\"removeFromTarget\",\"assignedThrough\":\"managed/role/593bee03-1f4a-49ff-a8fd-8002f8114155\"}]}}},{\"_id\":\"dc2e09c9-910d-45d5-b55b-8ebb8f631495\",\"_rev\":\"1\",\"userName\":\"superadmin\",\"displayName\":\"Super Admin\",\"description\":\"This is the description for Super Admin\",\"givenName\":\"Super\",\"mail\":\"superadmin@maildomain.net\",\"telephoneNumber\":\"+1 685 622 6202\",\"sn\":\"Admin\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:12 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"d7313737-3173-452f-b064-8123a4b7ec04\",\"_rev\":\"1\",\"userName\":\"systemadmin\",\"displayName\":\"System\",\"description\":\"This is the description for System Admin.\",\"givenName\":\"System\",\"mail\":\"systemadmin@maildomain.net\",\"telephoneNumber\":\"+1 154 428 0080\",\"sn\":\"Admin\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:12 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"5e3e8d9f-95ce-42ae-b34f-e21e35087598\",\"_rev\":\"5\",\"userName\":\"user.0\",\"displayName\":\"Aaccf Amar\",\"description\":\"This is the description for Aaccf Amar.\",\"givenName\":\"Aaccf\",\"mail\":\"user.0@maildomain.net\",\"telephoneNumber\":\"+1 685 622 6202\",\"sn\":\"Amar\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:10 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"3039a9ce-efce-4727-ae04-8075b1083f38\",\"_rev\":\"1\",\"userName\":\"user.1\",\"displayName\":\"Aaren Atp\",\"description\":\"This is the description for Aaren Atp.\",\"givenName\":\"Aaren\",\"mail\":\"user.1@maildomain.net\",\"telephoneNumber\":\"+1 390 103 6917\",\"sn\":\"Atp\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:10 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"d9944fc1-c0bb-4fa7-acd8-bae66668746b\",\"_rev\":\"1\",\"userName\":\"user.10\",\"displayName\":\"Abbey Abbie\",\"description\":\"This is the description for Abbey Abbie.\",\"givenName\":\"Abbey\",\"mail\":\"user.10@maildomain.net\",\"telephoneNumber\":\"+1 883 194 7070\",\"sn\":\"Abbie\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:12 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"d7a42435-d3ba-47b4-8f9b-1b5ed585c42c\",\"_rev\":\"1\",\"userName\":\"user.11\",\"displayName\":\"Abbi Abbott\",\"description\":\"This is the description for Abbi Abbott.\",\"givenName\":\"Abbi\",\"mail\":\"user.11@maildomain.net\",\"telephoneNumber\":\"+1 591 537 3301\",\"sn\":\"Abbott\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:11 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"ac7ba936-5f1e-49f2-91c9-6d5c2f3ece6c\",\"_rev\":\"1\",\"userName\":\"user.12\",\"displayName\":\"Abbie Abdalla\",\"description\":\"This is the description for Abbie Abdalla.\",\"givenName\":\"Abbie\",\"mail\":\"user.12@maildomain.net\",\"telephoneNumber\":\"+1 062 873 3050\",\"sn\":\"Abdalla\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:10 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"c7735786-50e7-4125-9fa1-03361d1ab82b\",\"_rev\":\"1\",\"userName\":\"user.13\",\"displayName\":\"Abby Abdo\",\"description\":\"This is the description for Abby Abdo.\",\"givenName\":\"Abby\",\"mail\":\"user.13@maildomain.net\",\"telephoneNumber\":\"+1 049 261 0167\",\"sn\":\"Abdo\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:11 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null}],\"resultCount\":10,\"pagedResultsCookie\":\"10\",\"remainingPagedResults\":-1}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/managed/user/9082c2fd-451a-40d3-b194-0fd2f1bc8b98",
            [
                200, 
                {},
                "{\"mail\":\"newUser@newUserSite.com\",\"sn\":\"User\",\"address2\":\"\",\"givenName\":\"New\",\"city\":\"\",\"country\":\"\",\"postalCode\":\"\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\",\"managed/role/593bee03-1f4a-49ff-a8fd-8002f8114155\"],\"telephoneNumber\":\"\",\"stateProvince\":\"\",\"postalAddress\":\"\",\"userName\":\"newUser\",\"manager\":\"managed/user/85f0a540-0deb-4225-ad5a-a14375487dd4\",\"lastPasswordSet\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Thu Jun 04 2015 10:04:29 GMT-0700 (PDT)\",\"effectiveRoles\":[\"openidm-authorized\",\"managed/role/593bee03-1f4a-49ff-a8fd-8002f8114155\"],\"_id\":\"9082c2fd-451a-40d3-b194-0fd2f1bc8b98\",\"_rev\":\"3\",\"effectiveAssignments\":{\"yo\":{\"attributes\":[{\"name\":\"yo\",\"value\":\"yo\",\"assignmentOperation\":\"mergeWithTarget\",\"unassignmentOperation\":\"removeFromTarget\",\"assignedThrough\":\"managed/role/593bee03-1f4a-49ff-a8fd-8002f8114155\"}]}}}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/managed/user/85f0a540-0deb-4225-ad5a-a14375487dd4",
            [
                200, 
                {},
                "{\"displayName\":\"HR Admin\",\"description\":\"This is the description for HR Admin\",\"givenName\":\"HR\",\"mail\":\"hradmin@maildomain.net\",\"telephoneNumber\":\"+1 685 622 6202\",\"sn\":\"Admin\",\"userName\":\"hradmin\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:12 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":{},\"_id\":\"85f0a540-0deb-4225-ad5a-a14375487dd4\",\"_rev\":\"1\"}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/managed/user?_queryFilter=manager eq \"managed/user/9082c2fd-451a-40d3-b194-0fd2f1bc8b98\"&_pageSize=100&_sortKeys=userName",
            [
                200, 
                {},
                "{\"result\":[],\"resultCount\":0,\"pagedResultsCookie\":null,\"remainingPagedResults\":0}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/endpoint/linkedView/managed/user/9082c2fd-451a-40d3-b194-0fd2f1bc8b98",
            [
                200, 
                {},
                "{\"mail\":\"newUser@newUserSite.com\",\"sn\":\"User\",\"address2\":\"\",\"givenName\":\"New\",\"city\":\"\",\"country\":\"\",\"postalCode\":\"\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\",\"managed/role/593bee03-1f4a-49ff-a8fd-8002f8114155\"],\"telephoneNumber\":\"\",\"stateProvince\":\"\",\"postalAddress\":\"\",\"userName\":\"newUser\",\"manager\":\"managed/user/85f0a540-0deb-4225-ad5a-a14375487dd4\",\"lastPasswordSet\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Thu Jun 04 2015 10:04:29 GMT-0700 (PDT)\",\"effectiveRoles\":[\"openidm-authorized\",\"managed/role/593bee03-1f4a-49ff-a8fd-8002f8114155\"],\"_id\":\"9082c2fd-451a-40d3-b194-0fd2f1bc8b98\",\"_rev\":\"3\",\"effectiveAssignments\":{\"yo\":{\"attributes\":[{\"name\":\"yo\",\"value\":\"yo\",\"assignmentOperation\":\"mergeWithTarget\",\"unassignmentOperation\":\"removeFromTarget\",\"assignedThrough\":\"managed/role/593bee03-1f4a-49ff-a8fd-8002f8114155\"}]}},\"linkedTo\":[{\"linkQualifier\":\"default\",\"content\":{\"uid\":\"newUser\",\"sn\":\"User\",\"cn\":\"New User\",\"ldapGroups\":[],\"telephoneNumber\":null,\"givenName\":\"New\",\"employeeType\":null,\"dn\":\"uid=newUser,ou=People,dc=example,dc=com\",\"description\":null,\"mail\":\"newUser@newUserSite.com\",\"_id\":\"uid=newUser,ou=People,dc=example,dc=com\"},\"mappings\":[{\"name\":\"systemLdapAccounts_managedUser\",\"type\":\"source\"},{\"name\":\"managedUser_systemLdapAccounts\",\"type\":\"target\"}],\"linkType\":\"systemLdapAccounts_managedUser\",\"resourceName\":\"system/ldap/account/uid=newUser,ou=People,dc=example,dc=com\"}]}"
            ]
        );
    
        server.respondWith(
            "POST",   
            "/openidm/system/ldap?_action=test",
            [
                200, 
                {},
                "{\"name\":\"ldap\",\"enabled\":true,\"config\":\"config/provisioner.openicf/ldap\",\"objectTypes\":[\"__ALL__\",\"group\",\"account\"],\"connectorRef\":{\"connectorName\":\"org.identityconnectors.ldap.LdapConnector\",\"bundleName\":\"org.forgerock.openicf.connectors.ldap-connector\",\"bundleVersion\":\"[1.4.0.0,2.0.0.0)\"},\"displayName\":\"LDAP Connector\",\"ok\":true}"
            ]
        );
    
        server.respondWith(
            "DELETE",   
            "/openidm/managed/user/9082c2fd-451a-40d3-b194-0fd2f1bc8b98",
            [
                200, 
                {},
                "{\"mail\":\"newUser@newUserSite.com\",\"sn\":\"User\",\"address2\":\"\",\"givenName\":\"New\",\"city\":\"\",\"country\":\"\",\"postalCode\":\"\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\",\"managed/role/593bee03-1f4a-49ff-a8fd-8002f8114155\"],\"telephoneNumber\":\"\",\"stateProvince\":\"\",\"postalAddress\":\"\",\"userName\":\"newUser\",\"manager\":\"managed/user/85f0a540-0deb-4225-ad5a-a14375487dd4\",\"lastPasswordSet\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Thu Jun 04 2015 10:04:29 GMT-0700 (PDT)\",\"effectiveRoles\":[\"openidm-authorized\",\"managed/role/593bee03-1f4a-49ff-a8fd-8002f8114155\"],\"_id\":\"9082c2fd-451a-40d3-b194-0fd2f1bc8b98\",\"_rev\":\"3\",\"effectiveAssignments\":{\"yo\":{\"attributes\":[{\"name\":\"yo\",\"value\":\"yo\",\"assignmentOperation\":\"mergeWithTarget\",\"unassignmentOperation\":\"removeFromTarget\",\"assignedThrough\":\"managed/role/593bee03-1f4a-49ff-a8fd-8002f8114155\"}]}}}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/managed/user?_queryId=query-all-ids",
            [
                200, 
                {},
                "{\"result\":[{\"_id\":\"e5b6a78c-704e-4766-85c3-66ac06826228\",\"_rev\":\"1\"},{\"_id\":\"2d989ac8-c827-4dc3-b4cb-5ccf4ddabea6\",\"_rev\":\"1\"},{\"_id\":\"5e3e8d9f-95ce-42ae-b34f-e21e35087598\",\"_rev\":\"5\"},{\"_id\":\"601fc78d-ec21-4b87-a251-2d71eb4d9c18\",\"_rev\":\"1\"},{\"_id\":\"071bc8b0-7b69-4538-bfdc-44ff3eae664b\",\"_rev\":\"1\"},{\"_id\":\"772262d8-d9da-4094-bfbd-2716cd56d4b8\",\"_rev\":\"1\"},{\"_id\":\"87f4709b-c9a5-4717-a348-61d6bf2dc8be\",\"_rev\":\"1\"},{\"_id\":\"3039a9ce-efce-4727-ae04-8075b1083f38\",\"_rev\":\"1\"},{\"_id\":\"800d3398-6515-4e31-9d38-d62420ea4dd7\",\"_rev\":\"1\"},{\"_id\":\"e2f81f50-312f-4d21-85ca-c6013c813d14\",\"_rev\":\"1\"},{\"_id\":\"ac7ba936-5f1e-49f2-91c9-6d5c2f3ece6c\",\"_rev\":\"1\"},{\"_id\":\"268cc781-a725-4903-8063-f43c306e5d4e\",\"_rev\":\"1\"},{\"_id\":\"c7735786-50e7-4125-9fa1-03361d1ab82b\",\"_rev\":\"1\"},{\"_id\":\"d7a42435-d3ba-47b4-8f9b-1b5ed585c42c\",\"_rev\":\"1\"},{\"_id\":\"d9944fc1-c0bb-4fa7-acd8-bae66668746b\",\"_rev\":\"1\"},{\"_id\":\"ee7f510e-0456-4c6b-b0c2-72125432964b\",\"_rev\":\"1\"},{\"_id\":\"841bb59b-d753-4af8-ba67-9e70b87067a0\",\"_rev\":\"1\"},{\"_id\":\"172f47fb-7dae-4caa-90ce-7e15bc5f5614\",\"_rev\":\"1\"},{\"_id\":\"d8e92028-8abb-40ae-b760-607fcaa026f2\",\"_rev\":\"1\"},{\"_id\":\"c8ec8921-363e-4b4c-bf18-cd9035989c85\",\"_rev\":\"1\"},{\"_id\":\"dc2e09c9-910d-45d5-b55b-8ebb8f631495\",\"_rev\":\"1\"},{\"_id\":\"85f0a540-0deb-4225-ad5a-a14375487dd4\",\"_rev\":\"1\"},{\"_id\":\"d7313737-3173-452f-b064-8123a4b7ec04\",\"_rev\":\"1\"}],\"resultCount\":23,\"pagedResultsCookie\":null,\"remainingPagedResults\":-1}"
            ]
        );
    
        server.respondWith(
            "GET",   
            "/openidm/managed/user?_queryFilter=/_id sw \"\"&_pageSize=10&_sortKeys=userName&_pagedResultsOffset=0",
            [
                200, 
                {},
                "{\"result\":[{\"_id\":\"85f0a540-0deb-4225-ad5a-a14375487dd4\",\"_rev\":\"1\",\"userName\":\"hradmin\",\"displayName\":\"HR Admin\",\"description\":\"This is the description for HR Admin\",\"givenName\":\"HR\",\"mail\":\"hradmin@maildomain.net\",\"telephoneNumber\":\"+1 685 622 6202\",\"sn\":\"Admin\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:12 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"dc2e09c9-910d-45d5-b55b-8ebb8f631495\",\"_rev\":\"1\",\"userName\":\"superadmin\",\"displayName\":\"Super Admin\",\"description\":\"This is the description for Super Admin\",\"givenName\":\"Super\",\"mail\":\"superadmin@maildomain.net\",\"telephoneNumber\":\"+1 685 622 6202\",\"sn\":\"Admin\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:12 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"d7313737-3173-452f-b064-8123a4b7ec04\",\"_rev\":\"1\",\"userName\":\"systemadmin\",\"displayName\":\"System\",\"description\":\"This is the description for System Admin.\",\"givenName\":\"System\",\"mail\":\"systemadmin@maildomain.net\",\"telephoneNumber\":\"+1 154 428 0080\",\"sn\":\"Admin\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:12 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"5e3e8d9f-95ce-42ae-b34f-e21e35087598\",\"_rev\":\"5\",\"userName\":\"user.0\",\"displayName\":\"Aaccf Amar\",\"description\":\"This is the description for Aaccf Amar.\",\"givenName\":\"Aaccf\",\"mail\":\"user.0@maildomain.net\",\"telephoneNumber\":\"+1 685 622 6202\",\"sn\":\"Amar\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:10 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"3039a9ce-efce-4727-ae04-8075b1083f38\",\"_rev\":\"1\",\"userName\":\"user.1\",\"displayName\":\"Aaren Atp\",\"description\":\"This is the description for Aaren Atp.\",\"givenName\":\"Aaren\",\"mail\":\"user.1@maildomain.net\",\"telephoneNumber\":\"+1 390 103 6917\",\"sn\":\"Atp\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:10 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"d9944fc1-c0bb-4fa7-acd8-bae66668746b\",\"_rev\":\"1\",\"userName\":\"user.10\",\"displayName\":\"Abbey Abbie\",\"description\":\"This is the description for Abbey Abbie.\",\"givenName\":\"Abbey\",\"mail\":\"user.10@maildomain.net\",\"telephoneNumber\":\"+1 883 194 7070\",\"sn\":\"Abbie\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:12 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"d7a42435-d3ba-47b4-8f9b-1b5ed585c42c\",\"_rev\":\"1\",\"userName\":\"user.11\",\"displayName\":\"Abbi Abbott\",\"description\":\"This is the description for Abbi Abbott.\",\"givenName\":\"Abbi\",\"mail\":\"user.11@maildomain.net\",\"telephoneNumber\":\"+1 591 537 3301\",\"sn\":\"Abbott\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:11 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"ac7ba936-5f1e-49f2-91c9-6d5c2f3ece6c\",\"_rev\":\"1\",\"userName\":\"user.12\",\"displayName\":\"Abbie Abdalla\",\"description\":\"This is the description for Abbie Abdalla.\",\"givenName\":\"Abbie\",\"mail\":\"user.12@maildomain.net\",\"telephoneNumber\":\"+1 062 873 3050\",\"sn\":\"Abdalla\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:10 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"c7735786-50e7-4125-9fa1-03361d1ab82b\",\"_rev\":\"1\",\"userName\":\"user.13\",\"displayName\":\"Abby Abdo\",\"description\":\"This is the description for Abby Abdo.\",\"givenName\":\"Abby\",\"mail\":\"user.13@maildomain.net\",\"telephoneNumber\":\"+1 049 261 0167\",\"sn\":\"Abdo\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:11 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null},{\"_id\":\"268cc781-a725-4903-8063-f43c306e5d4e\",\"_rev\":\"1\",\"userName\":\"user.14\",\"displayName\":\"Abbye Abdollahi\",\"description\":\"This is the description for Abbye Abdollahi.\",\"givenName\":\"Abbye\",\"mail\":\"user.14@maildomain.net\",\"telephoneNumber\":\"+1 030 505 6190\",\"sn\":\"Abdollahi\",\"accountStatus\":\"active\",\"roles\":[\"openidm-authorized\"],\"lastPasswordSet\":\"\",\"postalCode\":\"\",\"stateProvince\":\"\",\"passwordAttempts\":\"0\",\"lastPasswordAttempt\":\"Mon Jun 01 2015 11:05:11 GMT-0700 (PDT)\",\"postalAddress\":\"\",\"address2\":\"\",\"country\":\"\",\"city\":\"\",\"effectiveRoles\":[\"openidm-authorized\"],\"effectiveAssignments\":null}],\"resultCount\":10,\"pagedResultsCookie\":\"10\",\"remainingPagedResults\":-1}"
            ]
        );
    };

});
