/**
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright (c) 2011-2013 ForgeRock AS. All rights reserved.
 *
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the License). You may not use this file except in
 * compliance with the License.
 *
 * You can obtain a copy of the License at
 * http://forgerock.org/license/CDDLv1.0.html
 * See the License for the specific language governing
 * permission and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL
 * Header Notice in each file and include the License file
 * at http://forgerock.org/license/CDDLv1.0.html
 * If applicable, add the following below the CDDL Header,
 * with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 */

/*global $, define, _ */

/**
 * @author mbilski
 */
define("org/forgerock/openidm/ui/util/delegates/SiteIdentificationDelegate", [
    "org/forgerock/commons/ui/common/util/Constants",
    "org/forgerock/commons/ui/common/main/AbstractDelegate",
    "org/forgerock/commons/ui/common/main/Configuration",
    "org/forgerock/commons/ui/common/main/EventManager"
], function(constants, AbstractDelegate, configuration, eventManager) {

    var endpointPath = constants.host + "/openidm/endpoint/siteIdentification",
        obj = new AbstractDelegate(endpointPath);

    obj.getSiteIdentificationForLogin = function(login, successCallback, errorCallback) {            
        obj.serviceCall({
            url: "?_queryId=siteIdentification&login=" + login,  
            type: "GET",
            success: function(data) {
                if(successCallback) {
                    successCallback(data.result[0]);
                }
            }, 
            error: errorCallback
        });
    };
    
    return obj;
});



